﻿(function () {

    "use strict";

    angular.module("enrServicesModule")
           .factory("regionsJsonParser", [function () {
               return {
                   validOfficesRegionsJsonExist: function (officeCategoryJson) {
                       return officeCategoryJson !== undefined && officeCategoryJson !== null &&
                              officeCategoryJson.OfficeCategory !== undefined && officeCategoryJson.OfficeCategory !== null &&
                              officeCategoryJson.OfficeCategory.Regions !== undefined && officeCategoryJson.OfficeCategory.Regions !== null &&
                              officeCategoryJson.OfficeCategory.Regions.Region !== undefined && officeCategoryJson.OfficeCategory.Regions.Region !== null;
                   },

                   getOfficesRegionsJsonAsArray: function(officeCategoryJson) {
                       var regionNode = officeCategoryJson.OfficeCategory.Regions.Region;
                       if (regionNode.length === undefined)
                           regionNode = [regionNode];

                       return regionNode;
                   },

                   validReferendumsDetailsJsonExist: function(referendumDetailJson) {
                       return referendumDetailJson !== undefined && referendumDetailJson !== null &&
                              referendumDetailJson.Region !== undefined && referendumDetailJson.Region !== null &&
                              referendumDetailJson.Region.Reporting_Regions !== undefined && referendumDetailJson.Region.Reporting_Regions !== null &&
                              referendumDetailJson.Region.Reporting_Regions.Regions !== undefined && referendumDetailJson.Region.Reporting_Regions.Regions !== null &&
                              referendumDetailJson.Region.Reporting_Regions.Regions.Referendums !== undefined && referendumDetailJson.Region.Reporting_Regions.Regions.Referendums !== null &&
                              referendumDetailJson.Region.Reporting_Regions.Regions.Referendums.Referendum !== undefined && referendumDetailJson.Region.Reporting_Regions.Regions.Referendums.Referendum !== null;
                   },

                   getReferendumsDetailJsonAsArray: function (referendumDetailJson) {
                       var referendumData = new Array();
                       if (referendumDetailJson.Region.Reporting_Regions) {
                           referendumData = referendumDetailJson.Region.Reporting_Regions.Regions.Referendums.Referendum;
                           if (referendumData.length === undefined)
                               referendumData = [referendumData];

                           return referendumData;
                       }
                       return referendumData;
                   }
               };
           }]);

}());